<?php
namespace SalvatoreEckel\T3wrapper\Controller;

/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2016 Salvatore Eckel <salvaracer@gmx.de>, ie
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * AjaxController
 */
class AjaxController extends AbstractController {
	function __construct() {
		// Define salt
		$caperssoup = $this->generateCaperssoup();
		$day = intval(date('d'))-1;
		$month = intval(date('m'))-1;
		define ("AJAX_SALT", $caperssoup[$month][$day]);
	}    

	/**
	 * action index
	 *
	 * @return void
	 */
	public function indexAction() {
		header('Content-Type: application/json');

		$output = array();
		$wrappers = $this->wrapperRepository->findAll();
		$users = $this->userRepository->findAll();

		//print_r($this->settings);
		echo "index action\n";

		$output['service']['count'] = count($wrappers);
		$output['user']['count'] = count($users);

		echo json_encode($output);

		exit;
	}

	/**
	 * action subscribe
	 *
	 * @return void
	 */
	public function subscribeAction() {
		//header('Content-Type: application/json');
		$output = array();
		$data = array();

		$output['status'] = 'danger';
		$output['message'] = 'whoami';

		// request data
		$email = $_REQUEST['em'];
		$email = filter_var($email, FILTER_SANITIZE_EMAIL);

		if (!empty($email) && !filter_var($email, FILTER_VALIDATE_EMAIL)) {
			$output['status'] = 'danger';
			$output['message'] = 'Please enter a valid e-mail address..';

			echo json_encode($output);
			exit;
		}

		$firstname = $_REQUEST['fn'];
		$firstname = filter_var($firstname, FILTER_SANITIZE_STRING);

		$lastname = $_REQUEST['ln'];
		$lastname = filter_var($lastname, FILTER_SANITIZE_STRING);

		$verifycode = $_REQUEST['vf'];
		$verifycode = filter_var($verifycode, FILTER_SANITIZE_STRING);

		$del = $_REQUEST['rm'];
		$del = filter_var($del, FILTER_SANITIZE_NUMBER_INT);

		$data['email'] = $email;
		$data['firstname'] = $firstname;
		$data['lastname'] = $lastname;
		$data['verifycode'] = $verifycode;

		if ($verifycode) {
			$user = array();

			$entries = $this->findAll(intval($this->settings['storagePid']));
			foreach ($entries as $key => $entry) {
				$code = md5($entry['email'].AJAX_SALT);
				if ($code == $data['verifycode']) {
					// map to user
					$user = $entry;
				}
			}

			if (!empty($user)) {
				if ($del == 1) {
					$output = $this->deleteEntry($user['email']);
				} else {
					$output = $this->checkAndUpdate($data,$output);
				}
			} else {
				$output['status'] = 'danger';
				$output['message'] = 'code is wrong';
			}
		} elseif ($email) {
			$output = $this->addOrManage($data,$output);
		} else {
			$output['status'] = 'warning';
			$output['message'] = 'whoami';
		}

		echo json_encode($output);
		exit;
	}

	/**
	 * action contact
	 *
	 * @return void
	 */
	public function contactAction() {
		//header('Content-Type: application/json');
		$output = array();
		$data = array();

		$output['status'] = 'danger';
		$output['message'] = 'whoami';

		// request data
		$email = $_REQUEST['em'];
		$email = filter_var($email, FILTER_SANITIZE_EMAIL);

		$message = $_REQUEST['mg'];
		$message = htmlspecialchars(strip_tags($_REQUEST['mg']));

		if (!empty($email) && !filter_var($email, FILTER_VALIDATE_EMAIL)) {
			$output['status'] = 'danger';
			$output['message'] = 'Please enter a valid e-mail address.';

			echo json_encode($output);
			exit;
		}

		if (empty($message)) {
			$output['status'] = 'danger';
			$output['message'] = 'Please leave a message.';

			echo json_encode($output);
			return 0;
		}

		$output['status'] = 'success';
		$output['message'] = 'Your message has been sent successfully.';

		$name = $_REQUEST['nm'];
		$name = filter_var($name, FILTER_SANITIZE_STRING);

		// send contact mail
		$headers = 'From: ' . $email . "\r\n" .
			'Reply-To: ' . $email . "\r\n";

		mail($this->settings['email_to'], 'Message from Contact form', $message,$headers);

		echo json_encode($output);

		exit;
	}

	/**
	 * show heart html
	 *
	 * @return void
	 */
	public function heartAction() {
		$zoom = isset($_REQUEST['z']) ? intval($_REQUEST['z']) : 50;
		$this->view->assign('zoom', ($zoom / 100));
	}

	/**
	 * action comments
	 *
	 * @return void
	 */
	public function commentsAction() {
		$output = array();
		$output['status'] = 'danger';
		$output['message'] = 'comment ti chiami?';


		if (isset($_REQUEST['i'])) {
			$uid = isset($_REQUEST['i']) ? intval($_REQUEST['i']) : 0;

			$result = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows(
				'uid',
				'tx_pwcomments_domain_model_comment',
				'deleted = 0 AND hidden = 0 AND pid = ' . $uid . ' ',
				'',
				'',
				''
			);

			$output['status'] = 'success';
			$output['message'] = count($result);
		}

		echo json_encode($output);
		exit;
	}
	/**
	 * action sitemap
	 *
	 * @return void
	 */
	public function sitemapAction() {
		$tree = $this->getPageTreeView();
		$newTree = array();

		foreach ($tree->tree as $key => $page) {
			$newTree[$key] = $page;

			/*$pagePath = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows(
				'pagepath',
				'tx_realurl_pathcache',
				"page_id = " . $page['row']['uid'] . " ",
				'',
				'',
				''
			);

			if (count($pagePath) && !empty($pagePath[0]['pagepath'])) {
				$newTree[$key]['pagePath'] = $pagePath[0]['pagepath'];
			} else {
			}*/
			$newTree[$key]['pagePath'] = 'index.php?id=' . $page['row']['uid'];
		}

		$this->view->assign('tree',$newTree);
	}

	/**
	 * action autoSuggest
	 *
	 * @return void
	 */
	public function autoSuggestAction() {
		$output = array();
		$output['status'] = 'info';
		$output['message'] = 'Such nach etwas..';

		$term = isset($_REQUEST['t']) ? strip_tags($_REQUEST['t']) : '';
		$term = str_replace('%', '', $term);
		if (!empty($term)) {
			$doktypeWhere = "AND (doktype = 1 OR doktype = 3 OR doktype = 4) ";

			$foundPagesFirst = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows(
				'uid,pid,title',
				'pages',
				"deleted = 0 AND hidden = 0 " . $doktypeWhere . "AND title LIKE ('%" . $term . "%') ",
				'',
				'',
				''
			);
			$foundContents = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows(
				'uid,pid,header',
				'tt_content',
				"deleted = 0 AND hidden = 0 AND (header LIKE '%" . $term . "%' OR bodytext LIKE '%" . $term . "%') ",
				'',
				'',
				''
			);

			$pids = "AND (";
			if (count($foundPagesFirst) > 0) {
				foreach ($foundPagesFirst as $keyFirst => $pageFirst) {
					if ($keyFirst < 1) {
						$pids .= "uid = " . $pageFirst['uid'] . " ";
					} else {
						$pids .= "OR uid = " . $pageFirst['uid'] . " ";
					}
				}
			}
			if (count($foundContents) > 0) {
				foreach ($foundContents as $key => $content) {
					if (empty($pids)) {
						$pids .= "AND (uid = " . $content['pid'] . " ";
					} else {
						$pids .= "OR uid = " . $content['pid'] . " ";
					}
				}

			}
			$pids .= ")";

			$wherePages = "deleted = 0 AND hidden = 0 AND nav_hide = 0 ";
			$wherePages .= $pids;

			$foundPages = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows(
				'uid,title',
				'pages',
				$wherePages,
				'',
				'',
				''
			);

			$output['pages'] = $foundPages;

			if (count($foundPages) > 0) {
				$output['status'] = 'success';
				$output['message'] = 'Es wurden ' . count($foundPages) . ' Ergebnisse gefunden.';
			} else {
				$output['status'] = 'info';
				$output['message'] = 'Ihre Suche hat keine Treffer erzielt.';
			}
		}

		echo json_encode($output);
		exit;
	}

	/**
	 * action fbData
	 *
	 * @return void
	 */
	public function fbDataAction() {
		// http://www.vrjunkie.de/?type=5555

		$id = $this->settings['id'];
		$appid = $this->settings['appid'];
		$appsecret = $this->settings['appsecret'];

		$json_url ='https://graph.facebook.com/'.$id.'?access_token='.$appid.'|'.$appsecret.'&fields=likes';
		$json = file_get_contents($json_url);
		$json_output = json_decode($json,1);
 
		$likes = ($json_output['likes']) ? intval($json_output['likes']) : 0;
		$this->view->assign('likes', $likes);
	}

	/**
	 * action login
	 *
	 * @return void
	 */
	public function loginAction() {
	}

	/**
	 * get all active subscriber
	 *
	 * @return array
	 */
	private function findAll() {
		$where = 'deleted=0 ';
		$where .= "AND pid = " . intval($this->settings['storagePid']) . " ";
		$groupby = '';
		$orderby = '';
		$limit = '';

		$result = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows(
			'*',
			$this->settings['table'],
			$where,
			$groupby,
			$orderby,
			$limit
		);

		return $result;
	}

	/**
	 * find by email
	 *
	 * @param string $email
	 *
	 * @return array
	 */
	private function findByEmail($email) {
		$where = 'deleted=0 AND hidden=0 ';
		$where .= "AND pid = " . intval($this->settings['storagePid']) . " ";
		$where .= $email ? "AND email = '" . $email . "' " : 'NOT_VALID_EMAIL';
		$groupby = '';
		$orderby = '';
		$limit = '';

		$result = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows(
			'uid, pid, email, first_name, last_name, hidden, deleted',
			$this->settings['table'],
			$where,
			$groupby,
			$orderby,
			$limit
		);

		return $result;
	}

	/**
	 * check code and update data
	 *
	 * @param array $data
	 * @param array $output
	 *
	 * @return array
	 */
	private function checkAndUpdate($data,$output) {
		$user = array();
		$fields = array();
		$entries = $this->findAll(intval($this->settings['storagePid']));

		foreach ($entries as $key => $entry) {
			$code = md5($entry['email'].AJAX_SALT);
			if ($code == $data['verifycode']) {
				// map to user
				$user = $entry;
			}
		}

		if ($data['firstname']) {
			$fields['first_name'] = $data['firstname'];
		}
		if ($data['lastname']) {
			$fields['last_name'] = $data['lastname'];
		}

		if (count($fields)) {
			$result = $GLOBALS['TYPO3_DB']->exec_UPDATEquery(
				$this->settings['table'],
				"email = '" . $user['email'] . "'",
				$fields
			);

			if ($result) {
				$output['status'] = 'success';
				$output['message'] = 'Your data were saved.';
			}
		} else {
			// show helper form is no fields given
			?>
			<form method="post" action="<?php echo htmlspecialchars($_SERVER["REQUEST_URI"]);?>"> 
			   E-Mail: <input type="text" readonly value="<?php echo $user['email'];?>">
			   <br><br>
			   Firstname: <input type="text" name="fn" value="<?php echo $user['first_name'];?>">
			   <br><br>
			   Lastname: <input type="text" name="ln" value="<?php echo $user['last_name'];?>">
			   <br><br>
			   <input type="submit" name="submit" value="Speichern"> 
			</form>
			<a href="<?php echo htmlspecialchars($_SERVER["REQUEST_URI"]);?>&rm=1">Click here</a> to unsubscribe this abonnement
			<?php
			$output = array('');
		}

		return $output;
	}

	/**
	 * add user or send manage abonnement email
	 *
	 * @param array $data
	 * @param array $output
	 *
	 * @return array
	 */
	private function addOrManage($data,$output) {
		$pid = intval($this->settings['storagePid']);

		$where = 'deleted=0 ';
		$where .= $data['email'] ? "AND email = '" . $data['email'] . "' " : '';
		$where .= "AND pid = " . $pid;
		$limit = '1';

		// check if user exists
		$result = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows(
			'uid',
			$this->settings['table'],
			$where,
			'',
			'',
			$limit
		);

		// TODO: model settings
		$typeNum = (isset($_REQUEST['type']) && !empty($_REQUEST['type'])) ? $_REQUEST['type'] : 0;

		$code = md5($data['email'].AJAX_SALT);
		if (count($result)) {
			$fields = array();

			$fields['hidden'] = 0;
			//$fields['deleted'] = 0;

			$result = $GLOBALS['TYPO3_DB']->exec_UPDATEquery(
				$this->settings['table'],
				"email = '" . $result['email'] . "'",
				$fields
			);

			// send mail for manage abonnement
			$message = "Edit abonnement for " . $data['email'] . ". Follow this link to edit your abonnement - " . $this->settings['baseUrl'] . "/?type=" . $typeNum . "vf=" . $code . "&em=" . $data['email'];

			$headers = 'From: ' . $this->settings['email_from'] . "\r\n" .
				'Reply-To: ' . $this->settings['email_from'] . "\r\n";

			mail($data['email'], 'Edit abonnement', $message,$headers);

			$output['status'] = 'info';
			$output['message'] = 'Check your INBOX to manage your abonnement.';
		} else {
			// insert user
			$result = $GLOBALS['TYPO3_DB']->exec_INSERTquery(
				$this->settings['table'],
				array(
					'tstamp' => time(),
					'email' => $data['email'],
					'first_name' => $data['firstname'],
					'last_name' => $data['lastname'],
					'pid' => $pid,
				)
			);
			// send mail for new user
			$message = "Welcome to your abonnements (" . $data['email'] . "). Follow this link to edit you abonnements - " . $this->settings['baseUrl'] . "/?type=" . $typeNum . "vf=" . $code . "&em=" . $data['email'];

			$headers = 'From: ' . $this->settings['email_from'] . "\r\n" .
				'Reply-To: ' . $this->settings['email_from'] . "\r\n";

			mail($data['email'], 'Welcome', $message,$headers);

			$output['status'] = 'success';
			$output['message'] = 'Welcome at ' . $this->settings['baseUrl'];
		}

		return $output;
	}

	/**
	 * set entry hidden=1
	 *
	 * @param email $email
	 *
	 * @return bool
	 */
	private function deleteEntry($email) {
		$output = array();
		$fields = array();

		$fields['hidden'] = 1;

		$foundActiveUser = $this->findByEmail($email);

		if (count($foundActiveUser) > 0) {
			$result = $GLOBALS['TYPO3_DB']->exec_UPDATEquery(
				$this->settings['table'],
				"email = '" . $email . "' AND hidden = '" . 0 . "' AND deleted = '" . 0 . "'",
				$fields
			);

			$output['status'] = 'success';
			$output['message'] = 'Entry deleted.';

			// send mail for manage abonnement
			$message = "The abonnement for " . $email . ". is closed now. Thank you for your interest up and goodbye." . $code;

			$headers = 'From: ' . $this->settings['email_from'] . "\r\n" .
				'Reply-To: ' . $this->settings['email_from'] . "\r\n";

			mail($data['email'], 'Abonnement closed', $message,$headers);
		} else {
			$output['status'] = 'success';
			$output['message'] = 'No entries were found. Nothing were deleted.';
		}

		return $output;
	}

	/**
	 * action cook caperssoup
	 *
	 * @return void
	 */
	public function cookCaperssoupAction() {
		header('Content-Type: application/json');

		$caperssoup = $this->generateCaperssoup();

		echo json_encode($caperssoup);
		exit;
	}

	/**
	 * generate caperssoup
	 *
	 * @return void
	 */
	private function generateCaperssoup() {
		$caperssoup = range(0, 12);

		foreach ($caperssoup as $key => $value) {
			$caperssoup[$key] = range(0, 32);
			foreach ($caperssoup[$key] as $keyInner => $salt) {
				$caperssoup[$key][$keyInner] = sha1("PLACEHOLDER" . $key . $keyInner);
			}
		}

		return $caperssoup;
	}
}