<?php
namespace SalvatoreEckel\T3wrapper\Domain\Model;

/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2016 Salvatore Eckel <salvaracer@gmx.de>, ie
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * Wrapper
 */
class Wrapper extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity {

	/**
	 * name
	 *
	 * @var string
	 * @validate NotEmpty
	 */
	protected $name = '';

	/**
	 * typeNum
	 *
	 * @var int
	 * @validate NotEmpty
	 */
	protected $typeNum = 0;

	/**
	 * admPanel
	 *
	 * @var bool
	 */
	protected $admPanel = FALSE;

	/**
	 * additionalHeaders
	 *
	 * @var string
	 */
	protected $additionalHeaders = '';

	/**
	 * disableAllHeaderCode
	 *
	 * @var bool
	 */
	protected $disableAllHeaderCode = FALSE;

	/**
	 * extensionName
	 *
	 * @var string
	 * @validate NotEmpty
	 */
	protected $extensionName = '';

	/**
	 * pluginName
	 *
	 * @var string
	 * @validate NotEmpty
	 */
	protected $pluginName = '';

	/**
	 * vendorName
	 *
	 * @var string
	 * @validate NotEmpty
	 */
	protected $vendorName = '';

	/**
	 * controller
	 *
	 * @var string
	 * @validate NotEmpty
	 */
	protected $controller = '';

	/**
	 * switchableControllerActions
	 *
	 * @var string
	 */
	protected $switchableControllerActions = '';

	/**
	 * abstractSettings
	 *
	 * @var string
	 */
	protected $abstractSettings = '';

	/**
	 * requests
	 *
	 * @var int
	 */
	protected $requests = 0;

	/**
	 * ip
	 *
	 * @var string
	 */
	protected $ip = '';

	/**
	 * storagePid
	 *
	 * @var int
	 */
	protected $storagePid = 0;

	/**
	 * Returns the name
	 *
	 * @return string $name
	 */
	public function getName() {
		return $this->name;
	}

	/**
	 * Sets the name
	 *
	 * @param string $name
	 * @return void
	 */
	public function setName($name) {
		$this->name = $name;
	}

	/**
	 * Returns the typeNum
	 *
	 * @return int $typeNum
	 */
	public function getTypeNum() {
		return $this->typeNum;
	}

	/**
	 * Sets the typeNum
	 *
	 * @param int $typeNum
	 * @return void
	 */
	public function setTypeNum($typeNum) {
		$this->typeNum = $typeNum;
	}

	/**
	 * Returns the admPanel
	 *
	 * @return bool $admPanel
	 */
	public function getAdmPanel() {
		return $this->admPanel;
	}

	/**
	 * Sets the admPanel
	 *
	 * @param bool $admPanel
	 * @return void
	 */
	public function setAdmPanel($admPanel) {
		$this->admPanel = $admPanel;
	}

	/**
	 * Returns the boolean state of admPanel
	 *
	 * @return bool
	 */
	public function isAdmPanel() {
		return $this->admPanel;
	}

	/**
	 * Returns the additionalHeaders
	 *
	 * @return string $additionalHeaders
	 */
	public function getAdditionalHeaders() {
		return $this->additionalHeaders;
	}

	/**
	 * Sets the additionalHeaders
	 *
	 * @param string $additionalHeaders
	 * @return void
	 */
	public function setAdditionalHeaders($additionalHeaders) {
		$this->additionalHeaders = $additionalHeaders;
	}

	/**
	 * Returns the disableAllHeaderCode
	 *
	 * @return bool $disableAllHeaderCode
	 */
	public function getDisableAllHeaderCode() {
		return $this->disableAllHeaderCode;
	}

	/**
	 * Sets the disableAllHeaderCode
	 *
	 * @param bool $disableAllHeaderCode
	 * @return void
	 */
	public function setDisableAllHeaderCode($disableAllHeaderCode) {
		$this->disableAllHeaderCode = $disableAllHeaderCode;
	}

	/**
	 * Returns the boolean state of disableAllHeaderCode
	 *
	 * @return bool
	 */
	public function isDisableAllHeaderCode() {
		return $this->disableAllHeaderCode;
	}

	/**
	 * Returns the extensionName
	 *
	 * @return string $extensionName
	 */
	public function getExtensionName() {
		return $this->extensionName;
	}

	/**
	 * Sets the extensionName
	 *
	 * @param string $extensionName
	 * @return void
	 */
	public function setExtensionName($extensionName) {
		$this->extensionName = $extensionName;
	}

	/**
	 * Returns the pluginName
	 *
	 * @return string $pluginName
	 */
	public function getPluginName() {
		return $this->pluginName;
	}

	/**
	 * Sets the pluginName
	 *
	 * @param string $pluginName
	 * @return void
	 */
	public function setPluginName($pluginName) {
		$this->pluginName = $pluginName;
	}

	/**
	 * Returns the vendorName
	 *
	 * @return string $vendorName
	 */
	public function getVendorName() {
		return $this->vendorName;
	}

	/**
	 * Sets the vendorName
	 *
	 * @param string $vendorName
	 * @return void
	 */
	public function setVendorName($vendorName) {
		$this->vendorName = $vendorName;
	}

	/**
	 * Returns the controller
	 *
	 * @return string $controller
	 */
	public function getController() {
		return $this->controller;
	}

	/**
	 * Sets the controller
	 *
	 * @param string $controller
	 * @return void
	 */
	public function setController($controller) {
		$this->controller = $controller;
	}

	/**
	 * Returns the switchableControllerActions
	 *
	 * @return string $switchableControllerActions
	 */
	public function getSwitchableControllerActions() {
		return $this->switchableControllerActions;
	}

	/**
	 * Sets the switchableControllerActions
	 *
	 * @param string $switchableControllerActions
	 * @return void
	 */
	public function setSwitchableControllerActions($switchableControllerActions) {
		$this->switchableControllerActions = $switchableControllerActions;
	}

	/**
	 * Returns the abstractSettings
	 *
	 * @return string $abstractSettings
	 */
	public function getAbstractSettings() {
		return $this->abstractSettings;
	}

	/**
	 * Sets the abstractSettings
	 *
	 * @param string $abstractSettings
	 * @return void
	 */
	public function setAbstractSettings($abstractSettings) {
		$this->abstractSettings = $abstractSettings;
	}

	/**
	 * Returns the settings
	 *
	 * @return string $settings
	 */
	public function getSettings() {
		// linebreaks to array
		$settings = explode("\n",$this->abstractSettings);

		foreach ($settings as $index => $setting) {
			// remove linebreaks
			$setting = preg_replace("/\r|\n/", "", $setting);

			// split one equal sign and ltrim() pre-spaces
			$property = ltrim(strstr($setting, "=", true));
			$value = ltrim(substr($setting, strpos($setting, "=") + 1));

			$settings[$index] = $value;
		}
		return $settings;
	}

	/**
	 * Returns the requests
	 *
	 * @return int $requests
	 */
	public function getRequests() {
		return $this->requests;
	}

	/**
	 * Sets the requests
	 *
	 * @param int $requests
	 * @return void
	 */
	public function setRequests($requests) {
		$this->requests = $requests;
	}

	/**
	 * Returns the ip
	 *
	 * @return string $ip
	 */
	public function getIp() {
		return $this->ip;
	}

	/**
	 * Sets the ip
	 *
	 * @param string $ip
	 * @return void
	 */
	public function setIp($ip) {
		$this->ip = $ip;
	}

	/**
	 * Returns the storagePid
	 *
	 * @return int $storagePid
	 */
	public function getStoragePid() {
		return $this->storagePid;
	}

	/**
	 * Sets the storagePid
	 *
	 * @param int $storagePid
	 * @return void
	 */
	public function setStoragePid($storagePid) {
		$this->storagePid = $storagePid;
	}
}